<button class="back_button" mat-button (click)="location.back()">
    <mat-icon>keyboard_arrow_left</mat-icon>
    Regresar
</button>
<div class="container" *ngIf="product">
    <div *ngIf="!loading" class="form">
        <h2>Modificar Producto</h2>
        <div class="form__row">
            <div>
                <mat-form-field>
                    <mat-label>Nombre del Producto</mat-label>
                    <input #name matInput [value]="product.name">
                </mat-form-field>
            </div>
            <div>
                <mat-form-field>
                    <mat-label>Tipo de producto</mat-label>
                    <mat-select  [(ngModel)]="product.type">
                        <mat-option [value]="type" *ngFor="let type of types">
                            {{type}}
                        </mat-option>
                    </mat-select>
                </mat-form-field>
            </div>
        </div>
        <div class="form__row">
            <div>
                <mat-form-field>
                    <mat-label>Descripción</mat-label>
                    <textarea #description matInput rows="4" [value]="product.description"></textarea>
                </mat-form-field>
            </div>
            <div>
                <mat-form-field>
                    <mat-label>SKU</mat-label>
                    <input #sku matInput [value]="product.sku">
                </mat-form-field>
            </div>
        </div>
        <div class="form__row">
            <div>
                <mat-form-field>
                    <mat-label>Precio Unitario</mat-label>
                    <span matPrefix>$ &nbsp;</span>
                    <input (input)="noNegative(price)" #price matInput type="number" [value]="product.price[0]">
                </mat-form-field>
            </div>
            <div>
                 <mat-form-field>
                    <mat-label>Unidad de precio</mat-label>
                    <mat-select [(ngModel)]="product.price[2]">
                        <mat-option [value]="unit" *ngFor="let unit of price_units">
                            {{unit}}
                        </mat-option>
                    </mat-select>
                </mat-form-field>
            </div>
        </div>
        <div class="form__row">
            <div>
                <mat-form-field>
                    <mat-label>Cantidad en inventario</mat-label>
                    <input (input)="noNegative(stock)" #stock matInput type="number" [value]="product.stock[0]">
                </mat-form-field>
            </div>
            <div>
                <mat-form-field>
                    <mat-label>Unidad de Inventario</mat-label>
                    <mat-select [(ngModel)]="product.stock[1]">
                        <mat-option [value]="unit" *ngFor="let unit of stock_units">
                            {{unit}}
                        </mat-option>
                    </mat-select>
                </mat-form-field>
            </div>
        </div>
        <div class="form__row">
            <div>
                <mat-form-field>
                    <mat-label>Unidades de venta</mat-label>
                    <mat-select (selectionChange)="addUnit($event)">
                        <mat-option *ngFor="let sell of selling_units" [value]="sell">
                            {{sell}}
                        </mat-option>
                    </mat-select>
                </mat-form-field>
                <mat-chip-list #chipList>
                    <mat-chip
                    *ngFor="let type of product.units"
                    [removable]="true"
                    (removed)="removeUnit(type)">
                    {{type}}
                    <mat-icon matChipRemove>cancel</mat-icon>
                    </mat-chip>
                </mat-chip-list>
            </div>
        </div>
        <div class="form__row form__row_no-flex">
            <div>
                <h3 *ngIf="product.characteristics.length > 0">Caracteristicas del Producto</h3>
                <ul>
                    <li *ngFor="let characteristic of product.characteristics">
                        <span>{{characteristic}}</span>
                        <button style="margin-left: 20px;" color="warn" mat-icon-button (click)="removeChar(characteristic)">
                            Borrar
                            <mat-icon>delete</mat-icon>
                        </button>
                    </li>
                </ul>
                <h3 style="margin-top: 5px; margin-bottom: 5px;">
                    Escribe la característica y pulsa el botón "Agregar Característica" o ENTER:
                </h3>
                <mat-form-field>
                    <mat-label>Características</mat-label>
                    <input (keydown.enter)="addCharacteristic(characteristic)" #characteristic matInput placeholder="Escribe aquí ...">
                </mat-form-field>
                <button mat-flat-button color="primary"(click)="addCharacteristic(characteristic)">
                    Agregar Caracteristica
                </button>
            </div>
        </div>
        <div class="form__row form__row_no-flex">
            <div>
                <button mat-flat-button color="primary" (click)="uploader.click()">
                    Añadir Imágen
                    <input hidden type="file" #uploader
                        (change)="uploadFile($event)"
                        accept="image/*"
                    />
                </button>
                <div class="form__image-place">
                    <div *ngFor="let image of product.images">
                        <img [src]="image">
                        <button style="margin-left: 20px;" color="warn" mat-icon-button (click)="removeImage(image)">
                            Borrar
                            <mat-icon>delete</mat-icon>
                        </button>
                    </div>
                </div>
            </div>
        </div>
        <h2></h2>
        <div *ngIf="updating">
            <h1>Modificando tu producto</h1>
            <mat-spinner class="loading_screen__spinner"></mat-spinner>
        </div>
        <button [disabled]="updating" mat-flat-button color="accent" (click)="editProduct()">
            Agregar Nuevo Producto
        </button>
    </div>
</div>
<div *ngIf="loading" class="loading_screen">
    <h1>Añadiendo nuevo producto</h1>
    <mat-spinner class="loading_screen__spinner"></mat-spinner>
</div>